#ifndef IDEVTST_H
#define IDEVTST_H

/******************************************************************************/
/*                                          */
/*                                                                            */
/*     :                               */
/*    //                                     */
/*    IDeviceTest::Initialize                                                 */
/*    //                                        */
/*    IDeviceTest::GetStepsCount                                              */
/*    //                                         */
/*      IDeviceTest::GetStepName                                              */
/*      IDeviceTest::GetStepDescribe                                          */
/*    //           */
/*    //                                       */
/*      //                                           */  
/*      IDeviceTest::PrepareStep                                              */
/*      //                                      */
/*      //   "  M15    MC-227 sn00578  */
/*      //               12."                                */
/*      IDeviceTest::GetStepPrompt                                            */
/*                                                      */
/*      IDeviceTest::RunStep                                                  */
/*    //                                      */
/*    IDeviceTest::Finalize                                                   */
/*                                                                            */
/******************************************************************************/

// {76E7AD1E-8801-4b22-B676-BBB94CF39BCB}
static const GUID IID_IDeviceTest = 
{ 0x76e7ad1e, 0x8801, 0x4b22, { 0xb6, 0x76, 0xbb, 0xb9, 0x4c, 0xf3, 0x9b, 0xcb } };
//
enum
{
	TEST_OK = 0,
	TEST_FAIL = 1
};
//
class IDeviceTest : public IUnknown
{
public:
	
	///   
	virtual HRESULT STDMETHODCALLTYPE InitializeTest() = 0;
	
	///   
	virtual HRESULT STDMETHODCALLTYPE FinalizeTest() = 0;
	
	///   
	virtual ULONG   STDMETHODCALLTYPE GetTestStepsCount() = 0;
	
	///   
	/// a_nStepIndex      -  
	/// a_pchNameBuff     -     
	/// ULONG a_nBuffLen  -  
	virtual HRESULT STDMETHODCALLTYPE GetTestStepName(ULONG nStepIndex, char* pchNameBuff, ULONG nBuffLen) = 0;
	
	///   
	/// a_nStepIndex      -  
	/// a_pchDescribeBuff -     
	/// ULONG a_nBuffLen  -  
	virtual HRESULT STDMETHODCALLTYPE GetTestStepDescribe(ULONG nStepIndex, char* pchDescribeBuff, ULONG nBuffLen) = 0;
	
	///     
	/// a_nStepIndex      -  
	virtual HRESULT STDMETHODCALLTYPE PrepareTestStep(ULONG nStepIndex) = 0;

	///    
	/// a_nStepIndex      -  
	/// a_pchPromptBuff   -     
	/// ULONG a_nBuffLen  -  
	virtual HRESULT STDMETHODCALLTYPE GetTestStepPrompt(ULONG nStepIndex, char* pchPromptBuff, ULONG nBuffLen) = 0;
   
	///   
	/// a_nStepIndex      -  
	/// a_pchResultInfo   -       
	/// ULONG a_nBuffLen  -  
	virtual HRESULT STDMETHODCALLTYPE RunTestStep(ULONG a_nStepIndex, char* a_pchResultInfo, ULONG a_nBuffLen, DWORD *result)=0;

};
typedef IDeviceTest* PIDeviceTest;
#endif