#ifndef IPIPES_H
#define IPIPES_H

namespace mebius_daq{

using mebase::MEBRESULT;

enum{
	I_DATA_PIPEIN  = 1,	
	I_DATA_PIPEOUT = 2
};

class IPipeOut
{
public:
	virtual MEBRESULT MEBCALLTYPE Put(const void*p, int sz)=0;
};

class IPipeIn
{
public:
	virtual MEBRESULT MEBCALLTYPE OnGet(const void*p, int sz)=0;
};


enum{
	DATASTATUS_UNKNOWN = 0,
	DATASTATUS_VALID = 1,
	DATASTATUS_INVALID = 2
};

class IDataPipeOut
{
public:
	virtual MEBRESULT MEBCALLTYPE PutBlock(const void*p, int sz, mebase::ULONG counter, mebase::ULONG status)=0;
};

class IDataPipeIn
{
public:
	virtual MEBRESULT MEBCALLTYPE GetBlock(void*p, int sz, mebase::ULONG& counter, mebase::ULONG& status)=0;
};

class IDataPipe
{
public:
	virtual MEBRESULT MEBCALLTYPE PutData(const void*p, int sz, mebase::ULONG addr, int* szWrite=0, bool bAutoInc=0)=0;
	virtual MEBRESULT MEBCALLTYPE GetData(void*p, int sz, mebase::ULONG addr, int* szRead=0, bool bAutoInc=0)=0;	
};


}

#endif
