#ifndef ISCAN_H
#define ISCAN_H

#include "mebase.h"
#include "ITrigger.h"
#include "IChansList.h"

namespace mebius_daq{


class IChansList;
/// @interface IScan 
///   <br>
///     . <br>
///  - .     , 
///   .       
///   , -     .      
///   MAC  , ,     . 
///    ,  -        
///  .

class IScan
{
public:
	///  
	virtual MEBRESULT MEBCALLTYPE Start(
			ITrigger* pTrigger=0	//<  
		)=0;
	virtual MEBRESULT MEBCALLTYPE Stop(bool fAsync)=0;
	virtual MEBRESULT MEBCALLTYPE WaitStopping()=0;
	virtual MEBRESULT MEBCALLTYPE GetChansList(IChansList** ppList)=0;
};


/// @struct SAMPLE_PACKET     ( )
typedef struct 
{
	mebase::ULONG devid_;
	mebase::SHORT data_[1];
}SAMPLE_PACKET;

const size_t SAMPLE_PACKET_HEADER_SIZE=sizeof(mebase::ULONG);
const size_t SAMPLE_PACKET_SIZE=sizeof(SAMPLE_PACKET);


}
#endif

