#ifndef INVOKEIDBASE_H
#define INVOKEIDBASE_H
#include "mebase.h"



///      <br>
///   mebius_daq::IObject::Invoke
	
///     
#define MAKE_INVOKEID(classid, subtypeid, spec) \
    ((mebase::ULONG)((0xFE000000&((mebase::ULONG)(classid)<<25)) | (0x01FC0000&((mebase::ULONG)(subtypeid)<<18)) | ((mebase::ULONG)(spec)&0x0003FFFF)))

namespace mebius_daq{


const mebase::ULONG MEINVOKECLASSID_BASE    = 0 ;
const mebase::ULONG MEINVOKECLASSID_CHANNEL = 1 ;
const mebase::ULONG MEINVOKECLASSID_MB      = 2;
const mebase::ULONG MEINVOKECLASSID_MR      = 3;
}

enum
{
	MEINVOKE_START_FTP          = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  1),
	MEINVOKE_MOTOR              = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  2),
	MEINVOKE_CALIBR_TO_DEVEEP   = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  3),
	//        Flash
	MEINVOKE_WR_FLASH_DEVICE_INFO   = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  4),
	//        Flash
	MEINVOKE_RD_FLASH_DEVICE_INFO   = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  5),
	//       Flash
	MEINVOKE_WR_FACTORY_FLASH_CLB   = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  6),
	//  .     Flash
	MEINVOKE_WR_USER_FLASH_CLB  = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  7),
	//  .     Flash
	MEINVOKE_RD_USER_FLASH_CLB  = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  8),
	//       Flash
	MEINVOKE_RD_FACTORY_FLASH_CLB   = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  9),
	//    flash
	MEINVOKE_RELOAD_CLB			= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0xA),
	//         Flash
	MEINVOKE_WR_FLASH_CLB_INNER = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0xB),
	//   
	MEINVOKE_WR_NET_CONFIG		= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0xC),
	//   
	MEINVOKE_RD_NET_CONFIG		= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0xD),
	//  64-         
	MEINVOKE_SEV_GET_START_TIME		= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0xE),
	//  64-    
	MEINVOKE_SEV_GET_CUR_TIME		= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0xF),
	//        Flash
	MEINVOKE_WR_FLASH_CLB_RESET = MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0x10),
	//   
	MEINVOKE_RUN_MANIFOLD_MODE= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0x11),
	//    
	MEINVOKE_PUT_MANIFOLD= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0x12),
	//    
	MEINVOKE_SAVE_MANIFOLD= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0x13),
	//      
	MEINVOKE_SAVE_TO_FACTORY= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0x14),
	//      
	MEINVOKE_LOAD_FROM_FACTORY= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0x15),
	//   
	MEINVOKE_RD_MEM= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0x16),
	//   
	MEINVOKE_WR_SERIAL= MAKE_INVOKEID(mebius_daq::MEINVOKECLASSID_BASE, 0,  0x17),
};


#endif
