#ifndef ITAGSMANAGER_H
#define ITAGSMANAGER_H

#include "itag.h"



enum GETTAGFLAGS {

	GTF_HARDWARE  = 0x00001,
	GTF_VIRTUAL   = 0x00002,
	GTF_VECTOR    = 0x00004,
	GTF_SCALAR    = 0x00008,
	GTF_CONNECTED = 0x00010,  ///    LS_LOST,
	GTF_INPUT     = 0x00020,
	GTF_GENERIC   = GTF_HARDWARE | GTF_VIRTUAL | GTF_VECTOR | GTF_SCALAR | GTF_CONNECTED | GTF_INPUT,
	GTF_OUTPUT    = 0x00040,
	GTF_HIDDEN    = 0x00100,
	GTF_SYSTEM    = 0x00200,
	GTF_PIPE      = 0x00400,
	GTF_ALL       = 0x0FFFF
};

// {26E15AF5-D553-4d1f-B7DF-FC7BF5633BBE}
extern  const GUID IID_ITagsManager;


/// @interface ITagsManager     
///     IRecorder.    
///            
///   

class ITagsManager : public IUnknown
{
public:
	virtual HRESULT  STDMETHODCALLTYPE GetTagByIndexEx(ITag** ppTag, LONG nIndex, ULONG nFlags = GTF_GENERIC) = 0;
	virtual HRESULT  STDMETHODCALLTYPE GetTagsCountEx(LONG* pnCount, ULONG nFlags = GTF_GENERIC) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetTagIndexByPointerEx(LONG* pnIndex, ITag* pTag, ULONG nFlags = GTF_GENERIC) = 0;
};

#endif
