#ifndef ITIMEMASHINE_H
#define ITIMEMASHINE_H
#include "itag.h"

#pragma once


enum {
	TIMEFLAG_AS_VALUE,  ///       
	TIMEFLAG_AS_TIME,   ///       
	TIMEFLAG_AS_UTS,    ///        
	TIMEFLAG_AS_VALUEX  ///       x  X,Y
};

class ITimeMashine : public IUnknown
{
public:
	//          
	virtual double STDMETHODCALLTYPE GetSystemTime() const = 0;
	
	//         
	virtual double STDMETHODCALLTYPE GetUtsTime() const = 0;
};

// {1E1B1C81-F6E4-4349-95B9-69AC95EE89B3}
extern const GUID IID_ITimeMashineProps;


class ITimeMashineProps : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE SetUseExternalSysTimeFlag(VARIANT_BOOL a_flag) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetUseExternalUtsTimeFlag(VARIANT_BOOL a_flag) = 0;

	virtual HRESULT STDMETHODCALLTYPE GetUseExternalSysTimeFlag(VARIANT_BOOL* a_flag) const = 0;
	virtual HRESULT STDMETHODCALLTYPE GetUseExternalUtsTimeFlag(VARIANT_BOOL* a_flag) const = 0;

	virtual HRESULT STDMETHODCALLTYPE SetSysTimeChannel(ITag* m_pTag, LONG a_nFlags) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetUtsTimeChannel(ITag* m_pTag, LONG a_nFlags) = 0;

	virtual HRESULT STDMETHODCALLTYPE GetSysTimeChannel(ITag** m_ppTag, LONG* a_pnFlags) const = 0;
	virtual HRESULT STDMETHODCALLTYPE GetUtsTimeChannel(ITag** m_ppTag, LONG* a_pnFlags) const = 0;
	
	virtual HRESULT STDMETHODCALLTYPE SetSysTimeCorrector(double a_dblCorrector) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetUtsTimeCorrector(double a_dblCorrector) = 0;

	virtual HRESULT STDMETHODCALLTYPE GetSysTimeCorrector(double* a_pdblCorrector) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetUtsTimeCorrector(double* a_pdblCorrector) = 0;

};

#endif
