#ifndef CB_TOOLBAR_H
#define CB_TOOLBAR_H

// {894B2A27-D490-4e77-8CE0-6BCF20654C8A}
static const GUID IID_ICustomButtonsToolBar = 
{ 0x894b2a27, 0xd490, 0x4e77, { 0x8c, 0xe0, 0x6b, 0xcf, 0x20, 0x65, 0x4c, 0x8a } };
#include <ocidl.h>

typedef struct tagCB_MESSAGE
{
	ULONG uMsg;
	ULONG uID;
	ULONG uParam;
	IEnumUnknown* pObjects;
	HWND  hWnd;
}CB_MESSAGE, *PCB_MESSAGE;

//
//    
//
class ICustomButtonsToolBar: public IUnknown
{
public:
	//   
	//
	//     COM
	//        
	//
	virtual HRESULT STDMETHODCALLTYPE GetName(BSTR* pbstrName) = 0;

	//    
	virtual HRESULT STDMETHODCALLTYPE AddButton(
			IPicture* pPicture,         // [in]    
			IPicture* pPictureSel,      // [in]    ,   NULL
			IPicture* pPictureFocus,    // [in]     ,   NULL
			IPicture* pPictureDisabled, // [in]     ,   NULL
			const BSTR bstrCaption,     // [in]  
			const BSTR bstrToolTipText, // [in]   
			IUnknown* pOwner,           // [in]  
			ULONG* puID                 // [out]  
		) = 0;
	
	//    
	virtual HRESULT STDMETHODCALLTYPE RemoveButton(ULONG uID) = 0;

	// / 
	virtual HRESULT STDMETHODCALLTYPE EnableButton(ULONG uID, BOOL bEnable) = 0;

	///   
	/// -   
	virtual HRESULT STDMETHODCALLTYPE AddButtonMode(
			ULONG uID, ///     
			IPicture* pPicture,         // [in]    
			IPicture* pPictureSel,      // [in]    ,   NULL
			IPicture* pPictureFocus,    // [in]     ,   NULL
			IPicture* pPictureDisabled, // [in]     ,   NULL
			const BSTR bstrCaption,     // [in]  
			const BSTR bstrToolTipText, // [in]   
			ULONG* puID               // [out]  
		) = 0;
	
	///   /  
	virtual HRESULT STDMETHODCALLTYPE SelectMode(ULONG uID, ULONG nMode) = 0;

};

//////////////////////////////////////////////////////////////////////////////
// PN_CUSTOM_BUTTON_CLICK
//  uMsg;
//  uID         <- ID
//  uParam;
//  pObjects;
//
//////////////////////////////////////////////////////////////////////////////
// PN_CUSTOM_BUTTON_QUERY_STATE
//  uMsg        <- CBQS_TAGS, CBQS_HARDWARE, CBQS_PLUGINS, CBQS_GENERAL
//  uID         <- ID
//  uParam       -> (BOOL)Enabled?
//  pObjects;


#endif