///////////////////////////////////////////////////////////////////////////////
//  mr/iface                                                            
//       Tag data target
//
//  data target -        
//      
//      
//
//   data targets     
//
//    : datatrgt,h
//  : MVC++6.0                                                      
// 
//  (c)  "" 2004.
//
///////////////////////////////////////////////////////////////////////////////


#ifndef DATATRGT_H
#define DATATRGT_H

#include <unknwn.h>

// {BF43895D-88C3-4c1d-839B-1643B85CBDAA}
static const GUID IID_IDataTarget  = 
{ 0xbf43895d, 0x88c3, 0x4c1d, { 0x83, 0x9b, 0x16, 0x43, 0xb8, 0x5c, 0xbd, 0xaa } };

typedef DWORD TARGETTYPE;

enum{
	TT_BASE   = 0x0000, 
	TT_FILE   = 0x0001,
	TT_NET    = 0x0002,
	TT_BUFER  = 0x0004
};

#include "tgframe.h"

class IDataTarget : public IUnknown
{
public:


	virtual HRESULT       STDMETHODCALLTYPE LinkOwner(ITag* a_pOwner) PURE;
	virtual HRESULT       STDMETHODCALLTYPE SetPortionSize(DWORD a_dwPortionSize) PURE;
	virtual HRESULT       STDMETHODCALLTYPE Prepare() PURE;
	virtual HRESULT       STDMETHODCALLTYPE Start() PURE;
	virtual HRESULT       STDMETHODCALLTYPE Exec(tagFRAME* a_pData, DWORD a_dwStatus = 0) PURE;
	virtual HRESULT       STDMETHODCALLTYPE Reset() PURE;
	virtual HRESULT       STDMETHODCALLTYPE Finish() PURE;
	virtual HRESULT       STDMETHODCALLTYPE Flush() PURE;
	virtual HRESULT       STDMETHODCALLTYPE Stop() PURE;

	virtual HRESULT       STDMETHODCALLTYPE Enable() PURE;
	virtual HRESULT       STDMETHODCALLTYPE Disable() PURE;
	virtual BOOL          STDMETHODCALLTYPE IsEnabled() PURE;

	virtual HRESULT       STDMETHODCALLTYPE Activate() PURE;
	virtual HRESULT       STDMETHODCALLTYPE Deactivate() PURE;
	virtual BOOL          STDMETHODCALLTYPE IsActivated() PURE;



	virtual TARGETTYPE    STDMETHODCALLTYPE GetType() PURE;
	virtual LPCSTR        STDMETHODCALLTYPE GetName() PURE;
	virtual HRESULT       STDMETHODCALLTYPE Edit() PURE;

	//    
	virtual HRESULT       STDMETHODCALLTYPE Notify(DWORD a_dwCommand, DWORD a_dwParam=0) PURE;
	//  
	virtual HRESULT       STDMETHODCALLTYPE GetProperty(DWORD a_dwPropertyID, VARIANT& a_Value) PURE;
	//  
	virtual HRESULT       STDMETHODCALLTYPE SetProperty(DWORD a_dwPropertyID, VARIANT a_Value) PURE;


	//    
	virtual HRESULT       STDMETHODCALLTYPE Destroy() PURE;
	virtual HRESULT       STDMETHODCALLTYPE Create() PURE;


};

#endif