#ifndef IJOURNAL_H
#define IJOURNAL_H


// {95001261-E83C-11d6-9243-00E029288A7F}
static const GUID IID_IJournal = 
{ 0x95001261, 0xe83c, 0x11d6, { 0x92, 0x43, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };

// {95001262-E83C-11d6-9243-00E029288A7F}
static const GUID CLSID_Journal = 
{ 0x95001262, 0xe83c, 0x11d6, { 0x92, 0x43, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };



typedef struct{
  BSTR eventtext;
  long textcolor;
  long bkcolor;
  long priority;
}JOURNALEVENT;

enum{
  JPROP_DBFILE,
  JPROP_DBWRITE,
  JPROP_PARENTWINDOW,
  JPROP_VISIBLE,
  JPROP_SHOWTITLE,
  JPROP_SIZE
};

enum{
  EVPRIOR_CRITICAL,
  EVPRIOR_ALARM,
  EVPRIOR_WARNING,
  EVPRIOR_NORMAL
};


class IJournal : public IUnknown
{
  public:
    virtual HRESULT STDMETHODCALLTYPE AddEventRecord(JOURNALEVENT* a_jEvent)PURE;
    virtual HRESULT STDMETHODCALLTYPE AddEvent(BSTR a_bstrEventText, long a_lTtextColor, long a_lBKColor, long a_lPriority)PURE;
    virtual HRESULT STDMETHODCALLTYPE Reset()PURE;
    virtual HRESULT STDMETHODCALLTYPE GetProperty(DWORD a_dwPropID, VARIANT* a_varProp)PURE;
    virtual HRESULT STDMETHODCALLTYPE SetProperty(DWORD a_dwPropID, VARIANT a_varProp)PURE;
};

#endif