#ifndef IWAITWND_H
#define IWAITWND_H

// {2CE95502-E1F3-11d6-9243-00E029288A7F}
static const GUID CLSID_WaitingWindow = 
{ 0x2ce95502, 0xe1f3, 0x11d6, { 0x92, 0x43, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };

// {2CE95501-E1F3-11d6-9243-00E029288A7F}
static const GUID IID_IWaitingWindow = 
{ 0x2ce95501, 0xe1f3, 0x11d6, { 0x92, 0x43, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };


#include "wwpicid.h"

typedef enum{
	WWO_PROGRESSBAR     = 0x0001,
	WWO_EXTERNALIMAGE   = 0x0002,
	WWO_FINALIZENODELAY = 0x0004,
	WWO_STARTUPMODE     = 0x0008,
	WWO_ABORTBUTTON			= 0x0010
}WWOPTIONS;


class IWaitingWindow: public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE Init(const char* a_pchTitle, const char* a_pchMessage, DWORD a_dwPictureID, DWORD a_dwOptions=0, HWND a_hParent = NULL)PURE;
	virtual HRESULT STDMETHODCALLTYPE Show()PURE;
	virtual HRESULT STDMETHODCALLTYPE Hide()PURE;
	virtual HRESULT STDMETHODCALLTYPE SetMessageText(const char* a_pchMessage)PURE;
	virtual HRESULT STDMETHODCALLTYPE SetProgressPos(int a_nPos)PURE;
	virtual HRESULT STDMETHODCALLTYPE FinalizeProgress()PURE;
	virtual HRESULT STDMETHODCALLTYPE SetAdditionalText(const char* a_pchMessage,int a_nIndex)PURE;
	////  S_OK  S_FALSE
	virtual HRESULT STDMETHODCALLTYPE Aborted()PURE;

	///    
	virtual HRESULT STDMETHODCALLTYPE SetMessageTextFontSize(int a_nPoints) PURE;

};
typedef IWaitingWindow* PIWaitingWindow;

#endif


