//! @copyright ()  , 1996 - 2012. All rights reserved.
//! <http://www.nppmera.ru>
//!
//! @file rcplugin.h
//!
//! @date 2001-2012
//!
//! @author  ..
//! @brief  Recorder.   
//! @details    IRecorderPlugin.     
//!
//! @version 3.0



#ifndef RCPLUGIN_H
#define RCPLUGIN_H

#pragma once

#include "itypes.h"
#include "irecorder.h"

enum PLUGINTYPE{
	PLUGIN_CLASS,
	PLUGIN_HANDLE
};


///   /  .
///        PN_BEFORE_START

typedef struct tagSTARTCTRL
{
	///    ,    
	DWORD dwSize;

	/// 
	///   , ...
	DWORD dwFlags;

	///  ,         
	///      PN_ABORT_RCSTART
	BOOL bContinueAction;
	
	///   PN_ABORT_RCSTART        
	IUnknown* pObject;
	
}STARTCTRL, *PSTARTCTRL, ACTIONCTRL, *PACTIONCTRL; 


///       .
///          
typedef struct tagDATAPLACEMENT
{
	///  
	BSTR bstrDataFolder;
	///  
	BSTR bstrFrame;
}RCDATAPLACEMENT, *PRCDATAPLACEMENT;



///   @ref tagSTARTCTRL
enum STARTCTRLFAGS {
	SCF_VIEW        = 0x0001,
	SCF_REC         = 0x0002,
	SCF_PLAY        = 0x0004,
	SCF_ABORT       = 0x0008,
	SCF_PROGRAMMING = 0x0010,
	SCF_STOP        = 0x0020
};


/// 
enum PLUGIN_NOTIFY{
	PN_ENTERRCCONFIG,             ///<     
	PN_LEAVERCCONFIG,             ///<     
	PN_CHANGECURTAG,              ///<   , data=ITag*
	PN_RCSTART,                   ///<     / 
	PN_RCPLAY,                    ///<      
	PN_RCSTOP,                    ///<  
	PN_UPDATEDATA,                ///<    ,  data  
	PN_SHOWINFO,                  ///<     
	                              ///<  data HWND    
	PN_RCSAVECONFIG,              ///<   
	                              ///< (bool)data    
	PN_RCLOADCONFIG,              ///<   
	PN_SYNCHRO_READ_DATA_BLOCK,   ///<  
	                              ///<  RCNOTIFY rcn;
	                              ///<  rcn.pSender = dynamic_cast<IUnknown*>(ITAG);
	                              ///<  rcn.lParam = (long)a_dwPortionLen;
	                              ///<  rcn.pvParam = a_pdblBuffer;
	PN_EDIT_VIRTUAL_TAG_PROPS,    ///<    
	                              ///<  
	                              ///<  RCNOTIFY rcn;
	                              ///<  rcn.pvParam=dynamic_cast<IUnknown*>(ITAG);
	PN_IMPORTSETTINGS,            ///<     
	PN_EXPORTSETTINGS,            ///<     
	PN_BEFORE_RCSTART,            ///<     / 
	PN_BEFORE_RCSTOP,             ///<  
	PN_ABORT_RCSTART,             ///<    
	PN_BROADCAST,                 ///<   
	PN_CUSTOM_BUTTON_CLICK,       ///<     
	                              ///< data==   CB_MESSAGE
	PN_CUSTOM_BUTTON_QUERY_STATE, ///< 
	PN_ENABLE_VTAG_SETUP_DLG,     ///<      
	                              ///<     
	                              ///<  data   IEnumUnknown   
	PN_EDIT_MULTI_VTAG_PROPS,     ///<  PN_EDIT_VIRTUAL_TAG_PROPS    
	                              ///<  RCNOTIFY rcn;
	                              ///<  rcn.punkParam=IEnumUnknown   
	PN_QUERY_VTAG_INFO,           ///<     
	                              ///<  RCNOTIFY rcn;    
	                              ///<  rcn.punkParam=ITag      
	                              ///<  
	                              ///<   rcn.bstrParam    
	                              ///<      COM
	PN_REMOVE_VTAGS,              ///<      
	                              ///<    
	                              ///<  RCNOTIFY rcn;
	                              ///<  rcn.punkParam=IEnumUnknown   
	PN_RCINITIALIZED,             ///<   
	PN_ON_CHANGE_DATAPLACEMENT,   ///<        
	                              ///<    DATAPLACEMENT
	PN_ON_BEFORE_FRAME_REMOVING,  ///<     
	                              ///<   -      
	                              ///<     BSTR  
	                              ///<     
	PN_ON_AFTER_FRAME_REMOVING,   ///<    -     
	PN_FILE_PROCESSING_COMPLETED, ///<     
	PN_ON_DESTROY_UI_SRV,         ///<      
	                              ///<      ,   
	                              ///<  ,   .  
	PN_ON_SWITCH_TO_UI_THREAD,    ///<     ,    
	                              ///<      
	                              ///<          
	PN_ON_CONFIG_MODE_COMPLETED,  ///<     ,   
	                              ///<         
	                              ///<     
	PN_ON_SWITCH_CALIBR_MODE,     ///<      
	PN_ON_RC_PROGRAMMING,         ///<     Recorder    ""  
	                              ///<        
	PN_ABORT_RC_PROGRAMMING,      ///<       
	PN_ON_UPDATE_SECURITY_STATE,  ///<    
	                              ///<     DWORD  
	PN_ON_UPDATE_MF_TITLE,        ///<    
	                              ///<   BSTR     ,  
	PN_ON_REC_MODE,               ///<      
	PN_ON_PLAY_MODE,              ///<      
	PN_ON_POPUP_SETUP_DIALOG,     ///<     
	                              ///<      (ACTIONCTRL)  
	                              ///<        
	PN_ON_POPUP_SEL_FRAME_DIALOG, ///<       
	                              ///<      (ACTIONCTRL)  
	                              ///<        
	PN_ON_ACTION_SAVE_CFG,        ///<    
	PN_ON_ACTION_SAVE_CFG_AS,     ///<    
	PN_ON_ACTION_LOAD_CFG,        ///<    
	PN_ON_CHANGE_FORMS,           ///<   :
	                              ///<  -  
	                              ///<  - /
	PN_ABORT_RCSTOP,              ///<     
	PN_ON_ACTION_CLOSE_APP,       ///<    
	PN_ON_ZBALANCE_VTAG,          ///<      


	PN_USER = 0x7000              ///<   PN_USER+XXXX

};




///  
enum{
	RCCT_FULLRESET   = 0x0000,
	RCCT_DEVICERESET,
	RCCT_SOFTWARERESET,
	RCCT_LINKSREFRESH
};

/// 
enum{
	PLGPROP_STATUSSTRING,        ///<   .   
	PLGPROP_INFOSTRING,          ///<    
	PLGPROP_STATE,               ///<  
	PLGPROP_CLB_ASSIGNED,        ///<      
	PLGPROP_ALLOW_SETTINGS_DLG,  ///<   
	PLGPROP_CFG_REPORT_INFO,     ///<         
	PLGPROP_ALLOW_VTAG_ZBALANCE, ///<      
	                             ///<      ,     
								 ///< [in] VT_UNKNOWN [out] VT_BOOL
	PLGPROP_USER = 0x7000        ///<   PLGPROP_USER+XXXX
};

//  
enum{
	PLGSTATE_SUSPENDED = 0x0001 ///<    
};

//typedef 
typedef struct {
	char name[101];
	char describe[201];
	char vendor[201];
	short version;
	short subversion;
}PLUGININFO;


typedef PLUGININFO* LPPLUGININFO;

// {5967D621-0C3B-11d7-9243-00E029288A7F}
static const GUID IID_IRecorderPlugin = 
	{ 0x5967d621, 0xc3b, 0x11d7, { 0x92, 0x43, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };



/// @interface IRecorderPlugin
///    
class  IRecorderPlugin: public IUnknown
{
	public:
		///  
		virtual bool STDMETHODCALLTYPE create(IRecorder* a_pOwner = 0 ) = 0;
		
		///  
		virtual bool STDMETHODCALLTYPE config() = 0;
		
		///   
		virtual bool STDMETHODCALLTYPE edit() = 0;

		/// 
		virtual bool   STDMETHODCALLTYPE execute() = 0;
		
		///  
		virtual bool   STDMETHODCALLTYPE suspend() = 0;
		
		///  
		virtual bool   STDMETHODCALLTYPE resume() = 0;
		
		///    
		virtual bool   STDMETHODCALLTYPE notify(DWORD dwCommand, DWORD dwData = 0) = 0;
		
		///  
		virtual LPCSTR STDMETHODCALLTYPE getname() = 0;
		
		///  
		virtual bool   STDMETHODCALLTYPE getproperty(DWORD dwPropertyID, VARIANT& Value) = 0;
		
		///  
		virtual bool   STDMETHODCALLTYPE setproperty(DWORD dwPropertyID, VARIANT Value) = 0;
		
		///      
		virtual bool   STDMETHODCALLTYPE canclose() = 0;
		
		///   
		virtual bool   STDMETHODCALLTYPE close() = 0;
};
#endif 