{---------------------------------------------------------------------}
{  ()  plug-in`    Recorder }
{      Recorder`    }
{   ()    }
{ : Borland Delphi 6.0                                      }
{  " " 2004.                                               }
{---------------------------------------------------------------------}
unit recorder;
interface
uses Windows, tags, modules;
{$ALIGN 8}
const
   //   
   RCERROR_NOERROR =              0;
   RCERROR_UNKNOWNERROR =         1;
   RCERROR_NOTIMPLEMENT =         2;
   RCERROR_PLUGINNOTCREATED =     3;
   RCERROR_OUTOFRANGE =           4;
   RCERROR_NOTFOUND =             5;
   RCERROR_DLLNOTFOUND =          6;
   RCERROR_FUNCTIONNOTFOUND =     7;
   RCERROR_CANTOPEN =             8;
   RCERROR_CANTCREATE =           9;
   RCERROR_SYSTEMBUSY =          10;
   RCERROR_FILENOTFOUND =        11;
   RCERROR_INVALIDARGUMENT =     12;
   RCERROR_INVALIDTYPECAST =     13;
   RCERROR_ALREADYEXIST =        14;
   RCERROR_ABNORMALTERMINATION = 15;
   RCERROR_NOTSUPPORTED =        16;
   RCERROR_ACCESSVIOLATION =     17;
   RCERROR_USERABORT =           18;
   RCERROR_ACCESSDENIED =        19;
   LAST_ERROR_INDEX =            RCERROR_ACCESSDENIED;

   //  Recorder`
   RS_STOP              = $0001;     // 
   RS_VIEW              = $0002;     //  
   RS_REC               = $0004;     //    
   RS_PLAYING           = $0008;     //  
   RS_BASESTATE         = RS_REC + RS_VIEW + RS_STOP + RS_PLAYING;
   RS_HARDWAREFAULT     = $0010;     //     
   RS_INITFAULT         = $0020;     //     
   RS_NEEDDEVICERESET   = $0040;     //  Reset 
   RS_NEEDHARDWARERESET = $0040;     //  Reset 

   RS_NEEDSOFTWARERESET = $0080;     //    
   RS_NEEDLINKSREFRESH  = $0100;     //   
   RS_FAULT             = RS_HARDWAREFAULT + RS_INITFAULT;

   RS_PLAYMODE          = $0200;     //      
   RS_SIGNALLOADED      = $0400;     //   

   RS_CONFIGCHANGED     = $0800;     //  ,  

   RS_CONFIGMODE        = $1000;     //  

   RS_PACKETLOST        = $00010000; //    
   RS_RECEIVEERROR      = $00020000; //   

   RS_TERMINATION       = $80000000; //   

   RS_FULLMASK          = $FFFFFFFF;

   //  
   RCN_RECONFIG =         0; // 
   RCN_VIEW =             1; //   
   RCN_REC =              2; //  
   RCN_STOP =             3; //  
   RCN_SHOW =             4; //    
   RCN_HIDE =             5; //   
   RCN_CLOSE =            6; //   
   RCN_SETCURFORM =       7; //  
   RCN_ENABLESETUP =      8; //  /  
   RCN_CLOSEPLUGIN =      9; //   
   RCN_SETCURTAG =       10; //      a_dwParam =  
   RCN_CHANGECURTAG =    11; //    =   + a_dwParam
   RCN_CHANGETAGRANGE =  12; //      use TAGRANGEDATA

   // 
   RCPROP_HOSTDEVICE =           0; // [in]    [out]  
   RCPROP_DATAFOLDER =           1; //   [in] [out]
   RCPROP_STARTRECLEVCTRLPROPS = 2; //      RCLEVELCONTROLPROPS [out]
   RCPROP_STARTTIME =            3; //   / VT_FILETIME [out]
   RCPROP_CALIBRDBNAME =         4; //      [out] VT_BST
   RCPROP_REFRESHPERIOD =        5; //  /       [in][out] VT_R8
   RCPROP_VIEWTIME =             6; //  /       [in][out] VT_R8

   //    
   //Config mode sharing flags
   CMSF_CONFIGCHANGED = $0001;   //    
   //    
   IESF_DEFAULTSETTINGS = $0001; // / 
                                 //  

   //                                
   STDSTRSIZE = 256;

   // 
   VSN_ENTERRCCONFIG = 0;  //    
   VSN_LEAVERCCONFIG = 1;  //    
   VSN_CHANGECURTAG  = 2;  //  ,   dwData
                           //  ,   .

   VSN_RCSAVECONFIG  = 8;  //  
   VSN_RCLOADCONFIG  = 9;  //  

   VSN_RCSTART       = 3;  //    
   VSN_RCPLAY        = 4;  //    
   VSN_RCSTOP        = 5;  // 
   VSN_BEFORE_RCSTART= 14; //    
   VSN_BEFORE_RCSTOP = 15; // 
   VSN_ABORT_RCSTART = 16; //   

   //  
   VSN_SPECIFIED =      $4000; //
   VSN_RESIZE =         $4001; //     ,
                               //   dwData   
                               //   TRect.
   VSN_CHANGEVIEWTIME = $4002; //  
   VSN_CHANGETIMESHIFT= $4003; //   
   VSN_CHANGERCSTATE  = $4004; //  Recorder 
                               //  dwData  .

   VSN_USER =           $7000; //  VFN_USER+XXXX


type
   //     - 
   HARDLINK = DWORD;
   //  
   LEVEL = (
      LV_EQUAL,
      LV_ABOVE,
      LV_BELOW
   );

   tagRCLEVELCONTROLPROPS = record
      pTag: ITag;
      pchTagName: array[0 .. STDSTRSIZE - 1] of char;
      dblLevel: double;
      level: LEVEL;
   end;
   RCLEVELCONTROLPROPS = tagRCLEVELCONTROLPROPS;
   PRCLEVELCONTROLPROPS = ^RCLEVELCONTROLPROPS;


   //  
   //RCN_CHANGETAGRANGE  -      
   tagTAGRANGEDATA = record
      pTag: ITag;       {   }
      dblBX: double;    { }
      dblBY: double;    { }
      dblEX: double;    { }
      dblEY: double;    { }
   end;
   TAGRANGEDATA = tagTAGRANGEDATA;
   PTAGRANGEDATA = ^TAGRANGEDATA;

   //   Recorder`
   RECORDERSTATE = DWORD;

   //  
   IVForm = interface;

   //     
   IRecorder = interface
   ['{EE880620-53EF-11d7-9244-00E029288A7F}']
      //   
      function RegisterIForm(const pIVForm: IVForm;
                            const lParam: longint): boolean; stdcall;
      //      
      function UnregisterIForm(const pIVForm: IVForm): boolean; stdcall;

      //     
      function GetIFormByName(const pchName: LPCSTR): pointer{IVForm}; stdcall;
      //     
      function GetIFormByIndex(const nIndex: ULONG): pointer{IVForm}; stdcall;

      //   
      function GetTagByName(const pchName: LPCSTR): pointer{ITag}; stdcall;
      //   
      function GetTagByIndex(const nIndex: ULONG): pointer{ITag}; stdcall;
      //  
      function GetTagsCount: ULONG; stdcall;

      //   
      function GetModuleByIndex(const nHostDeviceNum: ULONG;
                                const nIndex: ULONG): pointer{IModule}; stdcall;
      //  
      function GetModulesCount(const nHostDeviceNum: ULONG): ULONG; stdcall;

      //   
      function GetGroupByIndex(const nIndex: ULONG): pointer{ITagsGroup}; stdcall;
      //   
      function GetGroupsCount: ULONG; stdcall;

      //  
      function GetState(const rsMask: RECORDERSTATE): RECORDERSTATE; stdcall;
      //  
      function CheckState(const rsState: RECORDERSTATE): boolean; stdcall;

      //     
      function GetSignalFrameName: LPCSTR; stdcall;
      //     
      function GetSignalFolderName: LPCSTR; stdcall;

      //  
      function CreateTag(const pchName: LPCSTR; const ls: LINKSTATE;
                        var a_pParams): pointer{ITag}; stdcall;
      //  
      function CloseTag(const piTag: ITag): boolean; stdcall;

      //    
      function Notify(const dwCommand: DWORD; const dwParam: DWORD): boolean; stdcall;

      {   }
      procedure SetLastError(const dwErrorCode: DWORD); stdcall;
      {   }
      function GetLastError: DWORD; stdcall;
      {     }
      function ConvertErrorCodeToString(const dwErrorCode: DWORD): LPCSTR; stdcall;

      //  
      function GetProperty(const dwPropertyID: DWORD;
                          var Value: OleVariant): HRESULT; stdcall;
      //  
      function SetProperty(const dwPropertyID: DWORD;
                           {const} Value: OleVariant): HRESULT; stdcall;

      // 
      //    
      function SetEnvironmentCurDir(const pchDir: LPCSTR): boolean; stdcall;
      //    
      function GetEnvironmentCurDir(const pchDir: LPCSTR;
                                   const nLength: integer): boolean; stdcall;

      //      
      function GetEnvironmentVar(const pchVarID: LPCSTR;
                                var varVal: OleVariant): boolean; stdcall;
      //      
      function SetEnvironmentVar(const pchVarID: LPCSTR;
                                var varVal: OleVariant): boolean; stdcall;

      //      long
      function GetEnvironmentLong(const pchVarID: LPCSTR;
                                 var lVal: longint): boolean; stdcall;
      //      long
      function SetEnvironmentLong(const pchVarID: LPCSTR;
                                 const lVal: longint): boolean; stdcall;

      //      double
      function GetEnvironmentDouble(const pchVarID: LPCSTR;
                                   var dblVal: double): boolean; stdcall;
      //      double
      function SetEnvironmentDouble(const pchVarID: LPCSTR;
                                   const dblVal: double): boolean; stdcall;

      //      char*
      function GetEnvironmentString(const pchVarID: LPCSTR; const pchVal: LPCSTR;
                                   var pnLength: integer): boolean; stdcall;

      //      char*
      function SetEnvironmentString(const pchVarID: LPCSTR;
                                   const pchlVal: LPCSTR): boolean; stdcall;

      //      
      function LogMessage(const pchMessage: LPCSTR): boolean; stdcall;
      //  (handle)    
      function GetHWND: HWND; stdcall;
      //        
      function GetCurrentTag: pointer{ITag}; stdcall;
      // 
      function SetCurrentTag(const nIndex: ULONG): HRESULT; stdcall;

      //    
      // v1.06.2+
      function GetTagIndexByPointer(const pTag: ITag): integer; stdcall;

      //  
      // v1.09
      function GetDevicesCount: integer; stdcall;

      //    *.cfg
      // v1.09.2.3
      function GetProjectName: LPCSTR; stdcall;

      //  
      // v1.10
      function GetRcBasePath: LPCSTR; stdcall;

      //  
      //   
      // v1.10.1
      function GetGroupByName(const pchName: LPCSTR): pointer{ITagsGroup}; stdcall;
      // 
      function DeleteTagsGroup(const pGrp: ITagsGroup): HRESULT; stdcall;
      // 
      function CreateTagsGroup(const a_pchName: LPCSTR): pointer{ITagsGroup}; stdcall;

      // 
      function ImportSettings(const pchName: LPCSTR;
                             const dwFlags: DWORD): HRESULT; stdcall;
      // 
      function ExportSettings(const pchName: LPCSTR;
                             const dwFlags: DWORD): HRESULT; stdcall;

      //     
      //     

      //   
      function EnterConfigMode(const pInitiator: IUnknown;
                              const dwFlags: DWORD): HRESULT; stdcall;

      //   
      function LeaveConfigMode(const pInitiator: IUnknown;
                              const dwFlags: DWORD): HRESULT; stdcall;

      //    
      function GetConfigModeState(var dwFlags: DWORD): ULONG; stdcall;

      //   
      function GetConfigModeInitiator: pointer{IUnknown}; stdcall;

      //     

      //   
      function dvchGetAvailableChansCount: ULONG; stdcall;
      //     
      function dvchGetChansList(var pIDList: HARDLINK): HRESULT; stdcall;
      //     
      function dvchGetAddress(const hlID: HARDLINK; const pchAddress: LPCSTR;
                             var nBuffLen: integer): HRESULT; stdcall;
      //       
      function dvchGetDeviceName(const hlID: HARDLINK; const pchDeviceName: LPCSTR;
                                var nBuffLen: integer): HRESULT; stdcall;
      //       
      function dvchGetDeviceInfo(const hlID: HARDLINK; const pchDeviceInfo: LPCSTR;
                                var nBuffLen: integer): HRESULT; stdcall;
   end;

   //       
   TagsArray = array[0..0] of ITag;

   //     
   IVForm = interface
   ['{95001263-E83C-11d6-9243-00E029288A7F}']
      //     ,   
      function GetName: LPCSTR; stdcall;
      // 
      function Init(pParent: IRecorder; hParent: HWND; lParam: longint): boolean; stdcall;
      // HWND 
      function GetHWnd: HWND; stdcall;
      //   
      function Close: boolean; stdcall;
      function Prepare: boolean; stdcall;
      function Update: boolean; stdcall;
      // 
      function Repaint: boolean; stdcall;
      //   
      function LinkTags( var pTagsList: TagsArray;
                         var nTagsCount: ULONG): boolean; stdcall;
      // 
      function Activate: boolean; stdcall;
      // 
      function Deactivate: boolean; stdcall;
      //  
      function Edit: boolean; stdcall;
      //, , 
      function Notify(const dwCommand: DWORD; const dwData: DWORD): boolean; stdcall;
   end;

implementation
end.
